from django.conf import settings
from django.conf.urls import include
from django.conf.urls.static import static
from django.urls import re_path
from django.views.i18n import JavaScriptCatalog
import accueil
import annuaire

urlpatterns = [
    re_path(r"^annuaire/", include(("annuaire.urls", "annuaire"))),
    re_path(r"^auth/", include(("portailuser.urls", "portailuser"))),
    re_path(r"^cldj/", include(("club.urls", "cldj"))),
    re_path(r"^clubs/", include(("club.urls", "club"))),
    re_path(r"^blogs_favoris/", include(("blogs_favoris.urls", "blogs_favoris"))),
    re_path(r"^gestion/", include(("gestion.urls", "gestion"))),
    re_path(r"^live/", include(("live.urls", "live"))),
    re_path(r"^reinit_mdp/", include(("reinit_mdp.urls", "reinit_mdp"))),
    re_path(r"^inscriptions/", include(("inscriptions.urls", "inscriptions"))),
    re_path(r"^services/bdd/", include(("gestion_bdd.urls", "gestion_bdd"))),
    re_path(r"^services/edt/", include(("edt.urls", "edt"))),
    re_path(r"^services/formations/", include(("formations.urls", "formations"))),
    re_path(r"^services/frappe/", include(("frappe.urls", "frappe"))),
    re_path(r"^services/logement/", include(("logement.urls", "logement"))),
    re_path(r"^services/sondages/", include(("sondages.urls", "sondages"))),
    re_path(r"^anniversaire/", include(("anniversaire.urls", "anniversaire"))),
    re_path(r"^evenements/", include(("evenements.urls", "evenements"))),
    re_path(r"^jsi18n/$", JavaScriptCatalog.as_view(), None),
    re_path(r"^services/ecobox/", include(("ecobox.urls", "ecobox"))),
    re_path(r"^services/covoiturage/", include(("covoiturage.urls", "covoiturage"))),
    # Utilisation des capchas
    re_path(r"^captcha/", include("captcha.urls")),
    re_path(r"^", include(("accueil.urls", "accueil"))),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

# Profil -> parrain / recherche
urlpatterns += [
    re_path(r"^profil/supprimer/$", accueil.views.profil_supprimer, name="profil_supprimer"),
    re_path(
        r"^profil/ajout/(?P<uid>\w+)$",
        accueil.views.profil,
        name="profil_dest_recherche",
    ),
    re_path(
        r"^profil/recherche$",
        annuaire.views.adm_recherche,
        {"titre": "Trouver mon parrain", "redir": "profil_dest_recherche"},
        "profil_rechercher",
    ),
]
"""
Monkey patch : on corrige un comportement étrange du paquet bootstrap4
bootstrap4 affiche deux fois les erreurs liées aux champs (dans une alerte ET sous chaque champ)
On surcharge/écrase une des méthodes du renderer pour corriger ce problème.
"""

import bootstrap4.renderers


def _render_override(self):
    return self.render_errors(type="non_fields") + self.render_fields()


bootstrap4.renderers.FormRenderer._render = _render_override
